#
# phpBB2 - MySQL schema
#
# $Id: mysql_schema.sql,v 1.35.2.7 2003/06/10 12:42:31 psotfx Exp $
#

#
# Table structure for table 'phpbb_auth_access'
#
CREATE TABLE phpbb_auth_access (
   group_id mediumint(8) DEFAULT '0' NOT NULL,
   forum_id smallint(5) UNSIGNED DEFAULT '0' NOT NULL,
   auth_view tinyint(1) DEFAULT '0' NOT NULL,
   auth_read tinyint(1) DEFAULT '0' NOT NULL,
   auth_post tinyint(1) DEFAULT '0' NOT NULL,
   auth_reply tinyint(1) DEFAULT '0' NOT NULL,
   auth_edit tinyint(1) DEFAULT '0' NOT NULL,
   auth_delete tinyint(1) DEFAULT '0' NOT NULL,
   auth_sticky tinyint(1) DEFAULT '0' NOT NULL,
   auth_announce tinyint(1) DEFAULT '0' NOT NULL,
   auth_vote tinyint(1) DEFAULT '0' NOT NULL,
   auth_pollcreate tinyint(1) DEFAULT '0' NOT NULL,
   auth_attachments tinyint(1) DEFAULT '0' NOT NULL,
   auth_mod tinyint(1) DEFAULT '0' NOT NULL,
   KEY group_id (group_id),
   KEY forum_id (forum_id)
);


#
# Table structure for table 'phpbb_user_group'
#
CREATE TABLE phpbb_user_group (
   group_id mediumint(8) DEFAULT '0' NOT NULL,
   user_id mediumint(8) DEFAULT '0' NOT NULL,
   user_pending tinyint(1),
   KEY group_id (group_id),
   KEY user_id (user_id)
);

#
# Table structure for table 'phpbb_groups'
#
CREATE TABLE phpbb_groups (
   group_id mediumint(8) NOT NULL auto_increment,
   group_type tinyint(4) DEFAULT '1' NOT NULL,
   group_name varchar(40) NOT NULL,
   group_description varchar(255) NOT NULL,
   group_moderator mediumint(8) DEFAULT '0' NOT NULL,
   group_single_user tinyint(1) DEFAULT '1' NOT NULL,
   PRIMARY KEY (group_id),
   KEY group_single_user (group_single_user)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_banlist'
#
CREATE TABLE phpbb_banlist (
   ban_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   ban_userid mediumint(8) NOT NULL,
   ban_ip char(8) NOT NULL,
   ban_email varchar(255),
   PRIMARY KEY (ban_id),
   KEY ban_ip_user_id (ban_ip, ban_userid)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_categories'
#
CREATE TABLE phpbb_categories (
   cat_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   cat_title varchar(100),
   cat_order mediumint(8) UNSIGNED NOT NULL,
   PRIMARY KEY (cat_id),
   KEY cat_order (cat_order)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_config'
#
CREATE TABLE phpbb_config (
    config_name varchar(255) NOT NULL,
    config_value varchar(255) NOT NULL,
    PRIMARY KEY (config_name)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_confirm'
#
CREATE TABLE phpbb_confirm (
  confirm_id char(32) DEFAULT '' NOT NULL,
  session_id char(32) DEFAULT '' NOT NULL,
  code char(6) DEFAULT '' NOT NULL, 
  PRIMARY KEY  (session_id,confirm_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_disallow'
#
CREATE TABLE phpbb_disallow (
   disallow_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   disallow_username varchar(25) DEFAULT '' NOT NULL,
   PRIMARY KEY (disallow_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_forum_prune'
#
CREATE TABLE phpbb_forum_prune (
   prune_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   forum_id smallint(5) UNSIGNED NOT NULL,
   prune_days smallint(5) UNSIGNED NOT NULL,
   prune_freq smallint(5) UNSIGNED NOT NULL,
   PRIMARY KEY(prune_id),
   KEY forum_id (forum_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_forums'
#
CREATE TABLE phpbb_forums (
   forum_id smallint(5) UNSIGNED NOT NULL,
   cat_id mediumint(8) UNSIGNED NOT NULL,
   forum_name varchar(150),
   forum_desc text,
   forum_status tinyint(4) DEFAULT '0' NOT NULL,
   forum_order mediumint(8) UNSIGNED DEFAULT '1' NOT NULL,
   forum_posts mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   forum_topics mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   forum_last_post_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   prune_next int(11),
   prune_enable tinyint(1) DEFAULT '0' NOT NULL,
   auth_view tinyint(2) DEFAULT '0' NOT NULL,
   auth_read tinyint(2) DEFAULT '0' NOT NULL,
   auth_post tinyint(2) DEFAULT '0' NOT NULL,
   auth_reply tinyint(2) DEFAULT '0' NOT NULL,
   auth_edit tinyint(2) DEFAULT '0' NOT NULL,
   auth_delete tinyint(2) DEFAULT '0' NOT NULL,
   auth_sticky tinyint(2) DEFAULT '0' NOT NULL,
   auth_announce tinyint(2) DEFAULT '0' NOT NULL,
   auth_vote tinyint(2) DEFAULT '0' NOT NULL,
   auth_pollcreate tinyint(2) DEFAULT '0' NOT NULL,
   auth_attachments tinyint(2) DEFAULT '0' NOT NULL,
   PRIMARY KEY (forum_id),
   KEY forums_order (forum_order),
   KEY cat_id (cat_id),
   KEY forum_last_post_id (forum_last_post_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_posts'
#
CREATE TABLE phpbb_posts (
   post_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   topic_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   forum_id smallint(5) UNSIGNED DEFAULT '0' NOT NULL,
   poster_id mediumint(8) DEFAULT '0' NOT NULL,
   post_time int(11) DEFAULT '0' NOT NULL,
   poster_ip char(8) NOT NULL,
   post_username varchar(25),
   enable_bbcode tinyint(1) DEFAULT '1' NOT NULL,
   enable_html tinyint(1) DEFAULT '0' NOT NULL,
   enable_smilies tinyint(1) DEFAULT '1' NOT NULL,
   enable_sig tinyint(1) DEFAULT '1' NOT NULL,
   post_edit_time int(11),
   post_edit_count smallint(5) UNSIGNED DEFAULT '0' NOT NULL,
   PRIMARY KEY (post_id),
   KEY forum_id (forum_id),
   KEY topic_id (topic_id),
   KEY poster_id (poster_id),
   KEY post_time (post_time)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_posts_text'
#
CREATE TABLE phpbb_posts_text (
   post_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   bbcode_uid char(10) NOT NULL,
   post_subject char(60),
   post_text text,
   PRIMARY KEY (post_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_privmsgs'
#
CREATE TABLE phpbb_privmsgs (
   privmsgs_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   privmsgs_type tinyint(4) DEFAULT '0' NOT NULL,
   privmsgs_subject varchar(255) DEFAULT '0' NOT NULL,
   privmsgs_from_userid mediumint(8) DEFAULT '0' NOT NULL,
   privmsgs_to_userid mediumint(8) DEFAULT '0' NOT NULL,
   privmsgs_date int(11) DEFAULT '0' NOT NULL,
   privmsgs_ip char(8) NOT NULL,
   privmsgs_enable_bbcode tinyint(1) DEFAULT '1' NOT NULL,
   privmsgs_enable_html tinyint(1) DEFAULT '0' NOT NULL,
   privmsgs_enable_smilies tinyint(1) DEFAULT '1' NOT NULL,
   privmsgs_attach_sig tinyint(1) DEFAULT '1' NOT NULL,
   PRIMARY KEY (privmsgs_id),
   KEY privmsgs_from_userid (privmsgs_from_userid),
   KEY privmsgs_to_userid (privmsgs_to_userid)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_privmsgs_text'
#
CREATE TABLE phpbb_privmsgs_text (
   privmsgs_text_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   privmsgs_bbcode_uid char(10) DEFAULT '0' NOT NULL,
   privmsgs_text text,
   PRIMARY KEY (privmsgs_text_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_ranks'
#
CREATE TABLE phpbb_ranks (
   rank_id smallint(5) UNSIGNED NOT NULL auto_increment,
   rank_title varchar(50) NOT NULL,
   rank_min mediumint(8) DEFAULT '0' NOT NULL,
   rank_special tinyint(1) DEFAULT '0',
   rank_image varchar(255),
   PRIMARY KEY (rank_id)
);


# --------------------------------------------------------
#
# Table structure for table `phpbb_search_results`
#
CREATE TABLE phpbb_search_results (
  search_id int(11) UNSIGNED NOT NULL default '0',
  session_id char(32) NOT NULL default '',
  search_array text NOT NULL,
  PRIMARY KEY  (search_id),
  KEY session_id (session_id)
);


# --------------------------------------------------------
#
# Table structure for table `phpbb_search_wordlist`
#
CREATE TABLE phpbb_search_wordlist (
  word_text varchar(50) binary NOT NULL default '',
  word_id mediumint(8) UNSIGNED NOT NULL auto_increment,
  word_common tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY (word_text),
  KEY word_id (word_id)
);

# --------------------------------------------------------
#
# Table structure for table `phpbb_search_wordmatch`
#
CREATE TABLE phpbb_search_wordmatch (
  post_id mediumint(8) UNSIGNED NOT NULL default '0',
  word_id mediumint(8) UNSIGNED NOT NULL default '0',
  title_match tinyint(1) NOT NULL default '0',
  KEY post_id (post_id),
  KEY word_id (word_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_sessions'
#
# Note that if you're running 3.23.x you may want to make
# this table a type HEAP. This type of table is stored
# within system memory and therefore for big busy boards
# is likely to be noticeably faster than continually
# writing to disk ...
#
CREATE TABLE phpbb_sessions (
   session_id char(32) DEFAULT '' NOT NULL,
   session_user_id mediumint(8) DEFAULT '0' NOT NULL,
   session_start int(11) DEFAULT '0' NOT NULL,
   session_time int(11) DEFAULT '0' NOT NULL,
   session_ip char(8) DEFAULT '0' NOT NULL,
   session_page int(11) DEFAULT '0' NOT NULL,
   session_logged_in tinyint(1) DEFAULT '0' NOT NULL,
   PRIMARY KEY (session_id),
   KEY session_user_id (session_user_id),
   KEY session_id_ip_user_id (session_id, session_ip, session_user_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_smilies'
#
CREATE TABLE phpbb_smilies (
   smilies_id smallint(5) UNSIGNED NOT NULL auto_increment,
   code varchar(50),
   smile_url varchar(100),
   emoticon varchar(75),
   PRIMARY KEY (smilies_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_themes'
#
CREATE TABLE phpbb_themes (
   themes_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   template_name varchar(30) NOT NULL default '',
   style_name varchar(30) NOT NULL default '',
   head_stylesheet varchar(100) default NULL,
   body_background varchar(100) default NULL,
   body_bgcolor varchar(6) default NULL,
   body_text varchar(6) default NULL,
   body_link varchar(6) default NULL,
   body_vlink varchar(6) default NULL,
   body_alink varchar(6) default NULL,
   body_hlink varchar(6) default NULL,
   tr_color1 varchar(6) default NULL,
   tr_color2 varchar(6) default NULL,
   tr_color3 varchar(6) default NULL,
   tr_class1 varchar(25) default NULL,
   tr_class2 varchar(25) default NULL,
   tr_class3 varchar(25) default NULL,
   th_color1 varchar(6) default NULL,
   th_color2 varchar(6) default NULL,
   th_color3 varchar(6) default NULL,
   th_class1 varchar(25) default NULL,
   th_class2 varchar(25) default NULL,
   th_class3 varchar(25) default NULL,
   td_color1 varchar(6) default NULL,
   td_color2 varchar(6) default NULL,
   td_color3 varchar(6) default NULL,
   td_class1 varchar(25) default NULL,
   td_class2 varchar(25) default NULL,
   td_class3 varchar(25) default NULL,
   fontface1 varchar(50) default NULL,
   fontface2 varchar(50) default NULL,
   fontface3 varchar(50) default NULL,
   fontsize1 tinyint(4) default NULL,
   fontsize2 tinyint(4) default NULL,
   fontsize3 tinyint(4) default NULL,
   fontcolor1 varchar(6) default NULL,
   fontcolor2 varchar(6) default NULL,
   fontcolor3 varchar(6) default NULL,
   span_class1 varchar(25) default NULL,
   span_class2 varchar(25) default NULL,
   span_class3 varchar(25) default NULL,
   img_size_poll smallint(5) UNSIGNED,
   img_size_privmsg smallint(5) UNSIGNED,
   PRIMARY KEY  (themes_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_themes_name'
#
CREATE TABLE phpbb_themes_name (
   themes_id smallint(5) UNSIGNED DEFAULT '0' NOT NULL,
   tr_color1_name char(50),
   tr_color2_name char(50),
   tr_color3_name char(50),
   tr_class1_name char(50),
   tr_class2_name char(50),
   tr_class3_name char(50),
   th_color1_name char(50),
   th_color2_name char(50),
   th_color3_name char(50),
   th_class1_name char(50),
   th_class2_name char(50),
   th_class3_name char(50),
   td_color1_name char(50),
   td_color2_name char(50),
   td_color3_name char(50),
   td_class1_name char(50),
   td_class2_name char(50),
   td_class3_name char(50),
   fontface1_name char(50),
   fontface2_name char(50),
   fontface3_name char(50),
   fontsize1_name char(50),
   fontsize2_name char(50),
   fontsize3_name char(50),
   fontcolor1_name char(50),
   fontcolor2_name char(50),
   fontcolor3_name char(50),
   span_class1_name char(50),
   span_class2_name char(50),
   span_class3_name char(50),
   PRIMARY KEY (themes_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_topics'
#
CREATE TABLE phpbb_topics (
   topic_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   forum_id smallint(8) UNSIGNED DEFAULT '0' NOT NULL,
   topic_title char(60) NOT NULL,
   topic_poster mediumint(8) DEFAULT '0' NOT NULL,
   topic_time int(11) DEFAULT '0' NOT NULL,
   topic_views mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   topic_replies mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   topic_status tinyint(3) DEFAULT '0' NOT NULL,
   topic_vote tinyint(1) DEFAULT '0' NOT NULL,
   topic_type tinyint(3) DEFAULT '0' NOT NULL,
   topic_first_post_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   topic_last_post_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   topic_moved_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   PRIMARY KEY (topic_id),
   KEY forum_id (forum_id),
   KEY topic_moved_id (topic_moved_id),
   KEY topic_status (topic_status),
   KEY topic_type (topic_type)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_topics_watch'
#
CREATE TABLE phpbb_topics_watch (
  topic_id mediumint(8) UNSIGNED NOT NULL DEFAULT '0',
  user_id mediumint(8) NOT NULL DEFAULT '0',
  notify_status tinyint(1) NOT NULL default '0',
  KEY topic_id (topic_id),
  KEY user_id (user_id),
  KEY notify_status (notify_status)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_users'
#
CREATE TABLE phpbb_users (
   user_id mediumint(8) NOT NULL,
   user_active tinyint(1) DEFAULT '1',
   username varchar(25) NOT NULL,
   user_password varchar(32) NOT NULL,
   user_session_time int(11) DEFAULT '0' NOT NULL,
   user_session_page smallint(5) DEFAULT '0' NOT NULL,
   user_lastvisit int(11) DEFAULT '0' NOT NULL,
   user_regdate int(11) DEFAULT '0' NOT NULL,
   user_level tinyint(4) DEFAULT '0',
   user_posts mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   user_timezone decimal(5,2) DEFAULT '0' NOT NULL,
   user_style tinyint(4),
   user_lang varchar(255),
   user_dateformat varchar(14) DEFAULT 'd M Y H:i' NOT NULL,
   user_new_privmsg smallint(5) UNSIGNED DEFAULT '0' NOT NULL,
   user_unread_privmsg smallint(5) UNSIGNED DEFAULT '0' NOT NULL,
   user_last_privmsg int(11) DEFAULT '0' NOT NULL,
   user_emailtime int(11),
   user_viewemail tinyint(1),
   user_attachsig tinyint(1),
   user_allowhtml tinyint(1) DEFAULT '1',
   user_allowbbcode tinyint(1) DEFAULT '1',
   user_allowsmile tinyint(1) DEFAULT '1',
   user_allowavatar tinyint(1) DEFAULT '1' NOT NULL,
   user_allow_pm tinyint(1) DEFAULT '1' NOT NULL,
   user_allow_viewonline tinyint(1) DEFAULT '1' NOT NULL,
   user_notify tinyint(1) DEFAULT '1' NOT NULL,
   user_notify_pm tinyint(1) DEFAULT '0' NOT NULL,
   user_popup_pm tinyint(1) DEFAULT '0' NOT NULL,
   user_rank int(11) DEFAULT '0',
   user_avatar varchar(100),
   user_avatar_type tinyint(4) DEFAULT '0' NOT NULL,
   user_email varchar(255),
   user_icq varchar(15),
   user_website varchar(100),
   user_from varchar(100),
   user_sig text,
   user_sig_bbcode_uid char(10),
   user_aim varchar(255),
   user_yim varchar(255),
   user_msnm varchar(255),
   user_occ varchar(100),
   user_interests varchar(255),
   user_actkey varchar(32),
   user_newpasswd varchar(32),
   PRIMARY KEY (user_id),
   KEY user_session_time (user_session_time)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_vote_desc'
#
CREATE TABLE phpbb_vote_desc (
  vote_id mediumint(8) UNSIGNED NOT NULL auto_increment,
  topic_id mediumint(8) UNSIGNED NOT NULL DEFAULT '0',
  vote_text text NOT NULL,
  vote_start int(11) NOT NULL DEFAULT '0',
  vote_length int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY  (vote_id),
  KEY topic_id (topic_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_vote_results'
#
CREATE TABLE phpbb_vote_results (
  vote_id mediumint(8) UNSIGNED NOT NULL DEFAULT '0',
  vote_option_id tinyint(4) UNSIGNED NOT NULL DEFAULT '0',
  vote_option_text varchar(255) NOT NULL,
  vote_result int(11) NOT NULL DEFAULT '0',
  KEY vote_option_id (vote_option_id),
  KEY vote_id (vote_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_vote_voters'
#
CREATE TABLE phpbb_vote_voters (
  vote_id mediumint(8) UNSIGNED NOT NULL DEFAULT '0',
  vote_user_id mediumint(8) NOT NULL DEFAULT '0',
  vote_user_ip char(8) NOT NULL,
  KEY vote_id (vote_id),
  KEY vote_user_id (vote_user_id),
  KEY vote_user_ip (vote_user_ip)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_words'
#
CREATE TABLE phpbb_words (
   word_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   word char(100) NOT NULL,
   replacement char(100) NOT NULL,
   PRIMARY KEY (word_id)
);

#
# phpBB2 - attach_mod schema
#
# $Id: attach_mysql_schema.sql,v 1.2 2003/01/29 11:43:58 acydburn Exp $
#

#
# Table structure for table 'phpbb_attachments_config'
#
CREATE TABLE phpbb_attachments_config (
  config_name varchar(255) NOT NULL,
  config_value varchar(255) NOT NULL,
  PRIMARY KEY (config_name)
);

#
# Table structure for table 'phpbb_forbidden_extensions'
#
CREATE TABLE phpbb_forbidden_extensions (
  ext_id mediumint(8) UNSIGNED NOT NULL auto_increment, 
  extension varchar(100) NOT NULL, 
  PRIMARY KEY (ext_id)
);

#
# Table structure for table 'phpbb_extension_groups'
#
CREATE TABLE phpbb_extension_groups (
  group_id mediumint(8) NOT NULL auto_increment,
  group_name char(20) NOT NULL,
  cat_id tinyint(2) DEFAULT '0' NOT NULL, 
  allow_group tinyint(1) DEFAULT '0' NOT NULL,
  download_mode tinyint(1) UNSIGNED DEFAULT '1' NOT NULL,
  upload_icon varchar(100) DEFAULT '',
  max_filesize int(20) DEFAULT '0' NOT NULL,
  forum_permissions varchar(255) default '' NOT NULL,
  PRIMARY KEY group_id (group_id)
);

#
# Table structure for table 'phpbb_extensions'
#
CREATE TABLE phpbb_extensions (
  ext_id mediumint(8) UNSIGNED NOT NULL auto_increment,
  group_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
  extension varchar(100) NOT NULL,
  comment varchar(100),
  PRIMARY KEY ext_id (ext_id)
);

#
# Table structure for table 'phpbb_attachments_desc'
#
CREATE TABLE phpbb_attachments_desc (
  attach_id mediumint(8) UNSIGNED NOT NULL auto_increment,
  physical_filename varchar(255) NOT NULL,
  real_filename varchar(255) NOT NULL,
  download_count mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
  comment varchar(255),
  extension varchar(100),
  mimetype varchar(100),
  filesize int(20) NOT NULL,
  filetime int(11) DEFAULT '0' NOT NULL,
  thumbnail tinyint(1) DEFAULT '0' NOT NULL,
  PRIMARY KEY (attach_id),
  KEY filetime (filetime),
  KEY physical_filename (physical_filename(10)),
  KEY filesize (filesize)
);

#
# Table structure for table 'phpbb_attachments'
#
CREATE TABLE phpbb_attachments (
  attach_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL, 
  post_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL, 
  privmsgs_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
  user_id_1 mediumint(8) NOT NULL,
  user_id_2 mediumint(8) NOT NULL,
  KEY attach_id_post_id (attach_id, post_id),
  KEY attach_id_privmsgs_id (attach_id, privmsgs_id)
); 

#
# Table structure for table 'phpbb_quota_limits'
#
CREATE TABLE phpbb_quota_limits (
  quota_limit_id mediumint(8) unsigned NOT NULL auto_increment,
  quota_desc varchar(20) NOT NULL default '',
  quota_limit bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (quota_limit_id)


#
# Table structure for table 'phpbb_attach_quota'
#

#
# Portal 
#
CREATE TABLE phpbb_portal (
  portal_name varchar(255) NOT NULL default '',
  portal_value text NOT NULL,
  PRIMARY KEY  (`portal_name`)
);

#
# Portal
#

#
# Table structure for table `phpbb_pa_cat`
#

CREATE TABLE phpbb_pa_cat (
  cat_id int(10) NOT NULL auto_increment,
  cat_name text,
  cat_desc text,
  cat_parent int(50) default NULL,
  parents_data text NOT NULL,
  cat_order int(50) default NULL,
  cat_allow_file tinyint(2) NOT NULL default '0',
  cat_files mediumint(8) NOT NULL default '-1',
  cat_last_file_id mediumint(8) unsigned NOT NULL default '0',
  cat_last_file_name varchar(255) NOT NULL default '',
  cat_last_file_time INT(50) UNSIGNED DEFAULT '0' NOT NULL,
  auth_view tinyint(2) NOT NULL default '0',
  auth_read tinyint(2) NOT NULL default '0',
  auth_view_file tinyint(2) NOT NULL default '0',
  auth_upload tinyint(2) NOT NULL default '0',
  auth_download tinyint(2) NOT NULL default '0',
  auth_rate tinyint(2) NOT NULL default '0',
  auth_email tinyint(2) NOT NULL default '0',
  auth_view_comment tinyint(2) NOT NULL default '0',
  auth_post_comment tinyint(2) NOT NULL default '0',
  auth_edit_comment tinyint(2) NOT NULL default '0',
  auth_delete_comment tinyint(2) NOT NULL default '0',
  PRIMARY KEY  (cat_id)
) TYPE=MyISAM;

# --------------------------------------------------------

INSERT INTO phpbb_pa_cat VALUES (1, 'My Category', '', 0, '', 1, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
INSERT INTO phpbb_pa_cat VALUES (2, 'Test Cagegory', 'Just a test category', 1, '', 2, 1, 0, 0, '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);


CREATE TABLE phpbb_pa_auth (
   group_id mediumint(8) DEFAULT '0' NOT NULL,
   cat_id smallint(5) UNSIGNED DEFAULT '0' NOT NULL,
   auth_view tinyint(1) DEFAULT '0' NOT NULL,
   auth_read tinyint(1) DEFAULT '0' NOT NULL,
   auth_view_file tinyint(1) DEFAULT '0' NOT NULL,
   auth_upload tinyint(1) DEFAULT '0' NOT NULL,
   auth_download tinyint(1) DEFAULT '0' NOT NULL,
   auth_rate tinyint(1) DEFAULT '0' NOT NULL,
   auth_email tinyint(1) DEFAULT '0' NOT NULL,
   auth_view_comment tinyint(1) DEFAULT '0' NOT NULL,
   auth_post_comment tinyint(1) DEFAULT '0' NOT NULL,
   auth_edit_comment tinyint(1) DEFAULT '0' NOT NULL,
   auth_delete_comment tinyint(1) DEFAULT '0' NOT NULL,
   auth_mod tinyint(1) DEFAULT '0' NOT NULL,
   auth_search tinyint(1) DEFAULT '1' NOT NULL,
   auth_stats tinyint(1) DEFAULT '1' NOT NULL,
   auth_toplist tinyint(1) DEFAULT '1' NOT NULL,
   auth_viewall tinyint(1) DEFAULT '1' NOT NULL,
   KEY group_id (group_id),
   KEY cat_id (cat_id)
);

#
# Table structure for table `phpbb_pa_comments`
#

CREATE TABLE phpbb_pa_comments (
  comments_id int(10) NOT NULL auto_increment,
  file_id int(10) NOT NULL default '0',
  comments_text text NOT NULL,
  comments_title text NOT NULL,
  comments_time int(50) NOT NULL default '0',
  comment_bbcode_uid varchar(10) default NULL,
  poster_id mediumint(8) NOT NULL default '0',
  PRIMARY KEY  (comments_id),
  KEY comments_id (comments_id),
  FULLTEXT KEY comment_bbcode_uid (comment_bbcode_uid)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `phpbb_pa_config`
#

CREATE TABLE phpbb_pa_config (
  config_name varchar(255) NOT NULL default '',
  config_value varchar(255) NOT NULL default '',
  PRIMARY KEY  (config_name)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `phpbb_pa_custom`
#

CREATE TABLE phpbb_pa_custom (
  custom_id int(50) NOT NULL auto_increment,
  custom_name text NOT NULL,
  custom_description text NOT NULL,
  data text NOT NULL,
  field_order int(20) NOT NULL default '0',
  field_type tinyint(2) NOT NULL default '0',
  regex varchar(255) NOT NULL default '',
  PRIMARY KEY  (custom_id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `phpbb_pa_customdata`
#

CREATE TABLE phpbb_pa_customdata (
  customdata_file int(50) NOT NULL default '0',
  customdata_custom int(50) NOT NULL default '0',
  data text NOT NULL
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `phpbb_pa_download_info`
#

CREATE TABLE phpbb_pa_download_info (
  file_id mediumint(8) NOT NULL default '0',
  user_id mediumint(8) NOT NULL default '0',
  downloader_ip varchar(8) NOT NULL default '',
  downloader_os varchar(255) NOT NULL default '',
  downloader_browser varchar(255) NOT NULL default '',
  browser_version varchar(255) NOT NULL default ''
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `phpbb_pa_files`
#

CREATE TABLE phpbb_pa_files (
  file_id int(10) NOT NULL auto_increment,
  user_id mediumint(8) NOT NULL default '0',
  poster_ip varchar(8) NOT NULL default '',
  file_name text,
  file_size int(20) NOT NULL default '0',
  unique_name varchar(255) NOT NULL default '',
  real_name VARCHAR(255) NOT NULL,
  file_dir VARCHAR(255) NOT NULL,
  file_desc text,
  file_creator text,
  file_version text,
  file_longdesc text,
  file_ssurl text,
  file_sshot_link tinyint(2) NOT NULL default '0',
  file_dlurl text,
  file_time int(50) default NULL,
  file_update_time int(50) NOT NULL default '0',
  file_catid int(10) default NULL,
  file_posticon text,
  file_license int(10) default NULL,
  file_dls int(10) default NULL,
  file_last int(50) default NULL,
  file_pin int(2) default NULL,
  file_docsurl text,
  file_approved TINYINT(1) DEFAULT '1' NOT NULL,
  file_broken TINYINT(1) DEFAULT '0' NOT NULL,
  PRIMARY KEY  (file_id)
) TYPE=MyISAM;

# --------------------------------------------------------

#
# Table structure for table `phpbb_pa_license`
#

CREATE TABLE phpbb_pa_license (
  license_id int(10) NOT NULL auto_increment,
  license_name text,
  license_text text,
  PRIMARY KEY  (license_id)
) TYPE=MyISAM;
# --------------------------------------------------------


CREATE TABLE phpbb_pa_mirrors (
  mirror_id mediumint(8) NOT NULL auto_increment, 
  file_id int(10) NOT NULL,
  unique_name varchar(255) NOT NULL default '',
  file_dir VARCHAR(255) NOT NULL, 
  file_dlurl varchar(255) NOT NULL default '',
  mirror_location VARCHAR(255) NOT NULL default '',
  PRIMARY KEY  (mirror_id),
  KEY file_id (file_id)
) TYPE=MyISAM;

#
# Table structure for table `phpbb_pa_votes`
#

CREATE TABLE phpbb_pa_votes (
  user_id mediumint(8) NOT NULL default '0',
  votes_ip varchar(50) NOT NULL default '0',
  votes_file int(50) NOT NULL default '0',
  rate_point tinyint(3) unsigned NOT NULL default '0',
  voter_os varchar(255) NOT NULL default '',
  voter_browser varchar(255) NOT NULL default '',
  browser_version varchar(8) NOT NULL default '',
  KEY user_id (user_id),
  KEY votes_file (votes_file),
  KEY votes_ip (votes_ip),
  KEY voter_os (voter_os),
  KEY voter_browser (voter_browser),
  KEY browser_version (browser_version),
  KEY rate_point (rate_point)
) TYPE=MyISAM;


INSERT INTO phpbb_pa_config VALUES ('allow_comment_images', '0');
INSERT INTO phpbb_pa_config VALUES ('no_comment_image_message', '[No image please]');
INSERT INTO phpbb_pa_config VALUES ('allow_smilies', '1');
INSERT INTO phpbb_pa_config VALUES ('allow_comment_links', '1');
INSERT INTO phpbb_pa_config VALUES ('no_comment_link_message', '[No links please]');
INSERT INTO phpbb_pa_config VALUES ('settings_disable', '0');
INSERT INTO phpbb_pa_config VALUES ('allow_html', '1');
INSERT INTO phpbb_pa_config VALUES ('allow_bbcode', '1');
INSERT INTO phpbb_pa_config VALUES ('settings_topnumber', '10');
INSERT INTO phpbb_pa_config VALUES ('settings_newdays', '1');
INSERT INTO phpbb_pa_config VALUES ('settings_stats', '');
INSERT INTO phpbb_pa_config VALUES ('settings_viewall', '1');
INSERT INTO phpbb_pa_config VALUES ('settings_dbname', 'Download Database');
INSERT INTO phpbb_pa_config VALUES ('settings_dbdescription', '');
INSERT INTO phpbb_pa_config VALUES ('max_comment_chars', '5000');
INSERT INTO phpbb_pa_config VALUES ('tpl_php', '0');
INSERT INTO phpbb_pa_config VALUES ('settings_file_page', '20');
INSERT INTO phpbb_pa_config VALUES ('hotlink_prevent', '1');
INSERT INTO phpbb_pa_config VALUES ('hotlink_allowed', '');
INSERT INTO phpbb_pa_config VALUES ('sort_method', 'file_time');
INSERT INTO phpbb_pa_config VALUES ('sort_order', 'DESC');
INSERT INTO phpbb_pa_config (config_name, config_value) VALUES ('auth_search','0');
INSERT INTO phpbb_pa_config (config_name, config_value) VALUES ('auth_stats','0');
INSERT INTO phpbb_pa_config (config_name, config_value) VALUES ('auth_toplist','0');
INSERT INTO phpbb_pa_config (config_name, config_value) VALUES ('auth_viewall','0');
INSERT INTO phpbb_pa_config (config_name, config_value) VALUES ('max_file_size','262144');
INSERT INTO phpbb_pa_config (config_name, config_value) VALUES ('upload_dir','pafiledb/uploads/');
INSERT INTO phpbb_pa_config (config_name, config_value) VALUES ('screenshots_dir','pafiledb/images/screenshots/');
INSERT INTO phpbb_pa_config (config_name, config_value) VALUES ('forbidden_extensions','php, php3, php4, phtml, pl, asp, aspx, cgi');


ALTER TABLE phpbb_forums ADD auth_download TINYINT(2) DEFAULT '0' NOT NULL;
ALTER TABLE phpbb_forums ADD COLUMN forum_password varchar(20) NOT NULL DEFAULT ''  
ALTER TABLE phpbb_auth_access ADD auth_download TINYINT(1) DEFAULT '0' NOT NULL;  
ALTER TABLE phpbb_posts ADD post_attachment TINYINT(1) DEFAULT '0' NOT NULL;
ALTER TABLE phpbb_topics ADD topic_attachment TINYINT(1) DEFAULT '0' NOT NULL;
ALTER TABLE phpbb_privmsgs ADD privmsgs_attachment TINYINT(1) DEFAULT '0' NOT NULL;
ALTER TABLE phpbb_users ADD user_extra TINYINT(1) DEFAULT '0' not null;

ALTER TABLE phpbb_categories ADD cat_main_type CHAR(1);
ALTER TABLE phpbb_categories ADD cat_main MEDIUMINT(8) UNSIGNED DEFAULT '0' NOT NULL;
ALTER TABLE phpbb_categories ADD cat_desc TEXT NOT NULL;
ALTER TABLE phpbb_categories ADD icon VARCHAR(255);
ALTER TABLE phpbb_forums ADD forum_link VARCHAR(255);
ALTER TABLE phpbb_forums ADD forum_link_internal TINYINT(1) NOT NULL;
ALTER TABLE phpbb_forums ADD forum_link_hit_count TINYINT(1) NOT NULL;
ALTER TABLE phpbb_forums ADD forum_link_hit BIGINT(20) UNSIGNED NOT NULL;
ALTER TABLE phpbb_forums ADD icon VARCHAR(255);
ALTER TABLE phpbb_forums ADD main_type CHAR(1);
ALTER TABLE phpbb_users ADD user_sub_forum TINYINT(1) DEFAULT '1' NOT NULL;
ALTER TABLE phpbb_users ADD user_split_cat TINYINT(1) DEFAULT '1' NOT NULL;
ALTER TABLE phpbb_users ADD user_last_topic_title TINYINT(1) DEFAULT '1' NOT NULL;
ALTER TABLE phpbb_users ADD user_sub_level_links TINYINT(1) DEFAULT '2' NOT NULL;
ALTER TABLE phpbb_users ADD user_display_viewonline TINYINT(1) DEFAULT '2' NOT NULL;

ALTER TABLE phpbb_users ADD user_from_flag varchar(25) NULL AFTER user_from;

CREATE TABLE phpbb_flags (
   flag_id int(10) NOT NULL auto_increment,
   flag_name varchar(25),
   flag_image varchar(25),
   PRIMARY KEY (flag_id)
);

INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','usa','usa.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','afghanistan','afghanistan.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','albania','albania.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','algeria','algeria.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','andorra','andorra.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','angola','angola.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','antigua and barbuda','antiguabarbuda.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','argentina','argentina.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','armenia','armenia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','australia','australia.gif');

INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','austria','austria.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','azerbaijan','azerbaijan.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','bahamas','bahamas.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','bahrain','bahrain.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','bangladesh','bangladesh.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','barbados','barbados.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','belarus','belarus.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','belgium','belgium.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','belize','belize.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','benin','benin.gif');

INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','bhutan','bhutan.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','bolivia','bolivia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','bosnia herzegovina','bosnia_herzegovina.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','botswana','botswana.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','brazil','brazil.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','brunei','brunei.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','bulgaria','bulgaria.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','burkinafaso','burkinafaso.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','burma','burma.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','burundi','burundi.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','cambodia','cambodia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','cameroon','cameroon.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','canada','canada.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','central african rep','centralafricanrep.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','chad','chad.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','chile','chile.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','china','china.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','columbia','columbia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','comoros','comoros.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','congo','congo.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','costarica','costarica.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','croatia','croatia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','cuba','cuba.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','cyprus','cyprus.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','czech republic','czechrepublic.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','demrepcongo','demrepcongo.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','denmark','denmark.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','djibouti','djibouti.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','dominica','dominica.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','dominican rep','dominicanrep.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','ecuador','ecuador.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','egypt','egypt.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','elsalvador','elsalvador.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','eq guinea','eq_guinea.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','eritrea','eritrea.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','estonia','estonia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','ethiopia','ethiopia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','fiji','fiji.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','finland','finland.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','france','france.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','gabon','gabon.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','gambia','gambia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','georgia','georgia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','germany','germany.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','ghana','ghana.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','greece','greece.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','grenada','grenada.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','grenadines','grenadines.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','guatemala','guatemala.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','guinea','guinea.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','guineabissau','guineabissau.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','guyana','guyana.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','haiti','haiti.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','honduras','honduras.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','hong kong','hong_kong.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','hungary','hungary.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','iceland','iceland.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','india','india.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','indonesia','indonesia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','iran','iran.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','iraq','iraq.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','ireland','ireland.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','israel','israel.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','italy','italy.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','ivory coast','ivorycoast.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','jamaica','jamaica.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','japan','japan.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','jordan','jordan.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','kazakhstan','kazakhstan.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','kenya','kenya.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','kiribati','kiribati.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','kuwait','kuwait.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','kyrgyzstan','kyrgyzstan.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','laos','laos.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','latvia','latvia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','lebanon','lebanon.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','liberia','liberia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','libya','libya.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','liechtenstein','liechtenstein.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','lithuania','lithuania.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','luxembourg','luxembourg.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','macadonia','macadonia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','macau','macau.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','madagascar','madagascar.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','malawi','malawi.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','malaysia','malaysia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','maldives','maldives.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','mali','mali.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','malta','malta.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','mauritania','mauritania.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','mauritius','mauritius.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','mexico','mexico.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','micronesia','micronesia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','moldova','moldova.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','monaco','monaco.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','mongolia','mongolia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','morocco','morocco.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','mozambique','mozambique.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','namibia','namibia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','nauru','nauru.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','nepal','nepal.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','neth antilles','neth_antilles.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','netherlands','netherlands.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','new zealand','newzealand.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','nicaragua','nicaragua.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','niger','niger.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','nigeria','nigeria.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','north korea','north_korea.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','norway','norway.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','oman','oman.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','pakistan','pakistan.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','panama','panama.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','papua newguinea','papuanewguinea.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','paraguay','paraguay.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','peru','peru.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','philippines','philippines.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','poland','poland.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','portugal','portugal.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','puertorico','puertorico.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','qatar','qatar.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','rawanda','rawanda.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','romania','romania.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','russia','russia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','sao tome','sao_tome.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','saudiarabia','saudiarabia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','senegal','senegal.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','serbia','serbia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','seychelles','seychelles.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','sierraleone','sierraleone.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','singapore','singapore.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','slovakia','slovakia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','slovenia','slovenia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','solomon islands','solomon_islands.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','somalia','somalia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','south_korea','south_korea.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','south africa','southafrica.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','spain','spain.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','srilanka','srilanka.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','stkitts nevis','stkitts_nevis.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','stlucia','stlucia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','sudan','sudan.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','suriname','suriname.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','sweden','sweden.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','switzerland','switzerland.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','syria','syria.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','taiwan','taiwan.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','tajikistan','tajikistan.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','tanzania','tanzania.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','thailand','thailand.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','togo','togo.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','tonga','tonga.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','trinidad and tobago','trinidadandtobago.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','tunisia','tunisia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','turkey','turkey.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','turkmenistan','turkmenistan.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','tuvala','tuvala.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','uae','uae.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','uganda','uganda.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','uk','uk.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','ukraine','ukraine.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','uruguay','uruguay.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','ussr','ussr.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','uzbekistan','uzbekistan.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','vanuatu','vanuatu.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','venezuela','venezuela.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','vietnam','vietnam.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','western samoa','western_samoa.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','yemen','yemen.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','yugoslavia','yugoslavia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','zaire','zaire.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','zambia','zambia.gif');
INSERT INTO phpbb_flags (flag_id, flag_name, flag_image) VALUES ('','zimbabwe','zimbabwe.gif');

ALTER TABLE phpbb_users ADD user_split_global_announce TINYINT(1) DEFAULT '1' NOT NULL;
ALTER TABLE phpbb_users ADD user_split_announce TINYINT(1) DEFAULT '1' NOT NULL;
ALTER TABLE phpbb_users ADD user_split_sticky TINYINT(1) DEFAULT '1' NOT NULL;
ALTER TABLE phpbb_users ADD user_split_topic_split TINYINT(1) DEFAULT '0' NOT NULL;

ALTER TABLE phpbb_topics ADD topic_icon TINYINT(2);
ALTER TABLE phpbb_posts ADD post_icon TINYINT(2);
ALTER TABLE phpbb_posts ADD INDEX (post_icon);

INSERT INTO `phpbb_ranks` VALUES (9, 'phpBB++ N00b', 0, 0, 'images/ranks/rank0.gif');
INSERT INTO `phpbb_ranks` VALUES (10, 'phpBB++ Beginner', 20, 0, 'images/ranks/rank1.gif');
INSERT INTO `phpbb_ranks` VALUES (11, 'phpBB++ Learner', 50, 0, 'images/ranks/rank2.gif');
INSERT INTO `phpbb_ranks` VALUES (12, 'phpBB++ User', 75, 0, 'images/ranks/rank3.gif');
INSERT INTO `phpbb_ranks` VALUES (13, 'phpBB++ Student', 130, 0, 'images/ranks/rank4.gif');
INSERT INTO `phpbb_ranks` VALUES (14, 'phpBB++ Master', 160, 0, 'images/ranks/rank5.gif');
INSERT INTO `phpbb_ranks` VALUES (15, 'phpBB++ Grand Master', 250, 0, 'images/ranks/rank6.gif');

ALTER TABLE phpbb_users ADD user_birthday INT DEFAULT "999999" not null
ALTER TABLE phpbb_users ADD user_next_birthday_greeting INT DEFAULT "0" not null
INSERT INTO phpbb_config (config_name, config_value) VALUES ("birthday_required", "0")
INSERT INTO phpbb_config (config_name, config_value) VALUES ("birthday_greeting", "1")
INSERT INTO phpbb_config (config_name, config_value) VALUES ("max_user_age", "100")
INSERT INTO phpbb_config (config_name, config_value) VALUES ("min_user_age", "5")
INSERT INTO phpbb_config (config_name, config_value) VALUES ("birthday_check_day", "7")

ALTER TABLE phpbb_users ADD user_gender TINYINT not null DEFAULT "0"

CREATE TABLE phpbb_banner ( banner_id MEDIUMINT(8) UNSIGNED NOT NULL, banner_name VARCHAR(90) NOT NULL, banner_spot SMALLINT(1) UNSIGNED NOT NULL, banner_forum MEDIUMINT(8) UNSIGNED NOT NULL, banner_description VARCHAR(30) NOT NULL, banner_url VARCHAR(90) NOT NULL, banner_owner MEDIUMINT(8) NOT NULL, banner_click MEDIUMINT(8) UNSIGNED NOT NULL, banner_view MEDIUMINT(8) UNSIGNED NOT NULL, banner_weigth TINYINT(1) UNSIGNED DEFAULT "50" NOT NULL, banner_active TINYINT(1) NOT NULL, banner_timetype TINYINT(1) NOT NULL, time_begin INT(11) NOT NULL, time_end INT(11) NOT NULL, date_begin INT(11) NOT NULL, date_end INT(11) NOT NULL, banner_level TINYINT(1) NOT NULL, banner_level_type TINYINT(1) NOT NULL, banner_comment VARCHAR(50) NOT NULL, INDEX (banner_id))

CREATE TABLE phpbb_banner_stats ( banner_id MEDIUMINT(8) UNSIGNED NOT NULL, click_date int (11) NOT NULL, click_ip char(8) NOT NULL, click_user MEDIUMINT(8) NOT NULL, user_duration int (11) NOT NULL)

ALTER TABLE phpbb_users ADD user_passwd_change INT(11) NOT NULL
UPDATE phpbb_users SET user_passwd_change=user_regdate
UPDATE phpbb_users SET user_passwd_change=1070315105 WHERE user_level=1
INSERT INTO phpbb_config (config_name, config_value) VALUES ("max_password_age", "730")
ALTER TABLE phpbb_users ADD user_badlogin SMALLINT(5) NOT NULL
ALTER TABLE phpbb_users ADD user_blocktime INT(11) NOT NULL
ALTER TABLE phpbb_users ADD user_block_by VARCHAR (8)
INSERT INTO phpbb_config (config_name, config_value) VALUES ("block_time", "15")
INSERT INTO phpbb_config (config_name, config_value) VALUES ("max_login_error", "3")
INSERT INTO phpbb_config (config_name, config_value) VALUES ("min_password_len", "6")
INSERT INTO phpbb_config (config_name, config_value) VALUES ("force_complex_password", "0")
INSERT INTO phpbb_config (config_name, config_value) VALUES ("password_not_login", "1")
ALTER TABLE phpbb_groups ADD group_count INT (4) UNSIGNED DEFAULT "99999999"
ALTER TABLE phpbb_groups ADD group_count_max INT (4) UNSIGNED DEFAULT "99999999"
ALTER TABLE phpbb_groups ADD group_count_enable SMALLINT (2) UNSIGNED DEFAULT "0"